tff(elt,type,(elt : $tType)).
tff(mlt,type,(mlt : $tType)).

tff(e,type,(e : elt)).
tff(o,type,(o : (elt * elt) > elt)).
tff(b,type,(b : (elt * elt) > elt)).
tff(s,type,(s : (elt * elt) > elt)).
tff(ap,type,(ap : (mlt * elt) > elt)).

tff(id,type,(id : mlt)).
tff(olm,type,(olm : (mlt * elt) > mlt)).
tff(orm,type,(orm : (mlt * elt) > mlt)).
tff(bm,type,(bm : (mlt * elt) > mlt)).
tff(sm,type,(sm : (mlt * elt) > mlt)).

% tff(lid,axiom,(! [X:elt] : (o(e,X) = X))).
% tff(rid,axiom,(! [X:elt] : (o(X,e) = X))).
% tff(b1,axiom,(! [X:elt] : (! [Y:elt] : (b(X,o(X,Y)) = Y)))).
% tff(b2,axiom,(! [X:elt] : (! [Y:elt] : (o(X,b(X,Y)) = Y)))).
% tff(s1,axiom,(! [X:elt] : (! [Y:elt] : (s(o(X,Y),Y) = X)))).
% tff(s2,axiom,(! [X:elt] : (! [Y:elt] : (o(s(X,Y),Y) = X)))).

% tff(apid,axiom,(! [X:elt] : (ap(id,X) = X))).
% tff(apolm,axiom,(! [G:mlt] : (! [X:elt] : (! [Y:elt] : (ap(olm(G,Y),X) = o(Y,ap(G,X))))))).
% tff(aporm,axiom,(! [G:mlt] : (! [X:elt] : (! [Y:elt] : (ap(orm(G,Y),X) = o(ap(G,X),Y)))))).
% tff(bm,axiom,(! [G:mlt] : (! [X:elt] : (! [Y:elt] : (ap(bm(G,Y),X) = b(Y,ap(G,X))))))).
% tff(sm,axiom,(! [G:mlt] : (! [X:elt] : (! [Y:elt] : (ap(sm(G,Y),X) = s(ap(G,X),Y)))))).
tff(aim,axiom,(! [G:mlt] : (! [H:mlt] : (! [X:elt] : ((ap(G,e) = e & ap(H,e) = e) => ap(G,ap(H,X)) = ap(H,ap(G,X))))))).

tff(t,type,(t : (elt * elt) > elt)).
tff(l,type,(l : (elt * elt * elt) > elt)).
tff(r,type,(r : (elt * elt * elt) > elt)).
% tff(tdef,axiom,(! [U:elt] : (! [X:elt] : (t(U,X) = b(X,o(U,X)))))).
% tff(ldef,axiom,(! [U:elt] : (! [X:elt] : (! [Y:elt] : (l(U,X,Y) = b(o(Y,X),o(Y,o(X,U)))))))).
% tff(rdef,axiom,(! [U:elt] : (! [X:elt] : (! [Y:elt] : (r(U,X,Y) = s(o(o(U,X),Y),o(X,Y))))))).

tff(tmlt,axiom,(! [U:elt] : (! [X:elt] : (t(U,X) = ap(bm(orm(id,X),X),U))))).
tff(tinn,axiom,(! [U:elt] : (! [X:elt] : (ap(bm(orm(id,X),X),e) = e)))).
tff(lmlt,axiom,(! [U:elt] : (! [X:elt] : (! [Y:elt] : (l(U,X,Y) = ap(bm(olm(olm(id,X),Y),o(Y,X)),U)))))).
tff(linn,axiom,(! [X:elt] : (! [Y:elt] : (ap(bm(olm(olm(id,X),Y),o(Y,X)),e) = e)))).
% tff(rmlt,axiom,(! [U:elt] : (! [X:elt] : (! [Y:elt] : (r(U,X,Y) = ap(sm(orm(orm(id,X),Y),o(X,Y)),U)))))).
% tff(rinn,axiom,(! [X:elt] : (! [Y:elt] : (ap(sm(orm(orm(id,X),Y),o(X,Y)),e) = e)))).

tff(tllem,conjecture,(! [U:elt] : (! [X:elt] : (! [Y:elt] : (! [Z:elt] : (ap(bm(orm(id,Z),Z),ap(bm(olm(olm(id,X),Y),o(Y,X)),U)) = ap(bm(olm(olm(id,X),Y),o(Y,X)),ap(bm(orm(id,Z),Z),U)))))))).

